/*
 *	FEZ.h
 *
 *	Interface definitions for the FEZ package.
 */

#define MAXPATH				32
#define MAXPORTSTACK		8
#define WINDOWSEPARATION	100
#define SCROLLBARWIDTH		16
#define CONTROLINSET		16

#ifndef NIL
#define NIL ((void *)0L)
#endif

// Simple 3-D integer coordinates (for rectangles in the vertical plane)

typedef struct { short x; short y; } Point2D;

// Information about the start and end of a general zoom

typedef struct {
	Rect zoom;					// Global coordinates w/r/t its window
	WindowPtr win;				// Its window
	short width;				// of rectangle lines
	RgnHandle clip;				// Visible desktop in front of and including this window
	Point2D knot;				// Where zoom path should pass through zoom
	Point2D c0;					// Control points for next segment of spline
	Point2D c1;
			
	} ZoomRect, *ZoomRectPtr, **ZoomRectHandle;

/* Prototypes */

void			PushPort(GrafPtr port);
void			PopPort(void);

void			LinearZoomRect(Rect *smallRect, Rect *bigRect, int zoomUp);
void			ZoomCenterRect(Rect *smallRect, Rect *bigRect, short thick);
void			SingleSplineZoom(ZoomRect *start, ZoomRect *end, int opening);
void			MultipleSplineZoom(ZoomRectHandle zoomArray, int opening);
ZoomRectHandle	GetMultiZoom(ZoomRect *start, ZoomRect *end, int opening);

void			ComputeBezierSpline(Point2D *p0, Point2D *c1, Point2D *c2, Point2D *p3, Point *path, short numPoints);
